Package: org.apache.groovy.parser.antlr4.internal.atnmanager

## [Java] Class AtnManager

- org.apache.groovy.parser.antlr4.internal.atnmanager.AtnManager

-     public abstract class AtnManager
      extends Object

  Manage ATN to avoid memory leak

- - ### Nested Class Summary

    Nested classes
    Modifiers | Name | Description
    --- | --- | ---
    `protected class` | `AtnManager.AtnWrapper` |

  - ### Field Summary

    Fields
    Modifiers | Name | Description
    --- | --- | ---
    `static ReentrantReadWriteLock.ReadLock` | `READ_LOCK` |

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `protected abstract AtnManager.AtnWrapper` | `createAtnWrapper()`
    `` | `public ATN` | `getATN()`
    `` | `protected AtnManager.AtnWrapper` | `getAtnWrapper()`
    `` | `protected abstract boolean` | `shouldClearDfaCache()`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class Object` | `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### public static final ReentrantReadWriteLock.ReadLock READ_LOCK

  - ### Method Detail

    - #### protected abstract AtnManager.AtnWrapper createAtnWrapper()

    - #### public ATN getATN()

    - #### protected AtnManager.AtnWrapper getAtnWrapper()

    - #### protected abstract boolean shouldClearDfaCache()